#!/bin/bash

process=$1
keyword=$2
interval=$3
count=$4

if [ "$process" == '' ] || [ "$keyword" == '' ] || [ "$interval" == '' ] || [ "$count" == '' ] ; then
  echo "Usage  : $0 <process_name> <keyword> <interval> <count>"
  echo "Example: $0 mysqld btr 10 10"
  exit 3
fi

pid=`pidof $process`

if [ $(echo $pid | wc -w) -gt 1 ] ; then
  echo "Process $process has too man pids: $pid."
  exit 1
fi

exec_user=$USER
proc_user=$(ps -fp $pid | tail -n 1 | awk '{ print $1 }')

if [ "$exec_user" != "$proc_user" ] && [ "$exec_user" != 'root' ] ; then
  echo "You must be either $proc_user or root but you are $exec_user."
  exit 2
fi

process_name=$(which $process)

list=''
header="time;"$(nm $process_name | grep -vi ' t ' | grep btr | grep ' D ' | awk '{ print $3 }')
for i in $(nm $process_name | grep -vi ' t ' | grep btr | grep ' D ' | awk '{ print $1 }') ; do
  list="$list 0x$i"
done

echo $header | sed 's/\ /;/g'

i=1
while [ $i -lt $count ] ; do
  data=$(read_process_memory $pid $list)
  echo $(date "+%Y-%m-%d %H:%M:%S")';'$(echo $data | sed "s/\ /;/g")

  sleep $interval
  let i=i+1
done

exit 0
